<template>
  <Layout>
    <transliteration-box></transliteration-box>

    <div class="card">
      <p>
        Here is my experience of transliterating and romanizing myanmar words
        into latin characters to make reading and remembering myanmar words
        easier.<br />
        Besides basic transliteration of each system i haven't seen an easy
        detailed explanation of how to read more complex myanmar words.<br />
        For now i am seeing three levels of difficulty for myanmar
        reading/transliteration.<br />
      </p>
      <ul>
        <li>
          Basic transliteration consists of directly transliterating consonant
          and vowel and endOfSyllable into latin characters. It also includes
          consonant to voiced consonant changes after vowels and nasal finals (n
          and ng endings).
        </li>
        <li>
          Second level adds stacked word expansions. These contains 4 types.
          "stacked characters", "stacked abbreviations", "simplified stacked
          words" and "double consonants" which are also called "Modern Closing
          Consonants". Also there are at least two special characters which can
          also be seen as stacked characters. "ည" and "ဿ".<br />
          Since it is not possible to seperately read stacked characters i have
          also included stacked character into my written display. The only
          exception are "simplified stacked words" and the special characters
          since these add additional characters into the pronounciation.<br />
          Additionally the second level includes number weakening for 1,2 and 7.
          When these numbers are infront of a Classifier or noun+Classifier the
          last vowel of the number gets changed into a half vowel.
        </li>
        <li>
          Third level is a more phonetic natural pronounciation. This consists
          of half vowels and sandhi changes which depend on knowing if a
          syllable is part of the ending of a valid word. Also you need to know
          if after a syllable follows a valid word. This can only be done if you
          already have knowledge of myanmar words and can recognize them in
          compound words. I am currently trying to better understand how the
          rules are interacting to implement a better automatic transliteration.
        </li>
      </ul>
      <br />
      On my page
      <g-link to="/transliteration-rules/">Transliteration rules</g-link> you
      can see how i implement additional rules for stacked characters and trying
      out sandhi changes.<br />
      Also the page has a small list of sources where you can look up basic
      transliteration rules of each transliteration system. Popular
      transliteration systems are BGN, MLCS, Okell and IPA.
    </div>
    <div class="card">
      Unfortunately i haven't found a ready made script that transliterates
      myanmar to latin and handles stackedCharacters and numbers. Best script i
      had found was
      <a href="https://github.com/myanmaropenwordnet/mya2rom"
        >myanmaropenwordnet/mya2rom</a
      >. <br /><br />
      My script is still in development and needs to be cleaned up and
      optimized, but should cover basic transliteration. It is seperated into
      these 3 levels<br />
      <ol>
        <li>
          Written: Which character is exactly written + stacked character
          expansion (without simplified stacked words)
        </li>
        <li>
          Simple Spoken changes.
          <ul>
            <li>Consonant change after vowel and</li>
            <li>
              1,2,7 Number weakening infront of Classifier or noun+Classifier
              (Noun dictionary usage)
            </li>
            <li>simplified stacked word expansion</li>
          </ul>
        </li>
        <li>
          Extended Spoken (Noun+Verb dictionary usage)
          <ul>
            <li>Half vowel</li>
            <li>
              Sandhi
              <ul>
                <li>
                  voiced consonant pair matching after half vowel and following
                  voiced consonant after vowel or nasal finals (n/ng)
                </li>
                <li>Nasalized Consonant changes</li>
              </ul>
            </li>
          </ul>
        </li>
      </ol>
    </div>
    <div class="card">
      The script is an extended automatic romanization system with support for
      stacked characters / Conjunct Consonants. BGN pronounciation is primarly
      tested.
      <br />Most stacked characters seem to work. I have tried to implement
      "Stacked Characters", "Stacked Abbreviations", "Simplified Double Stacked
      Words" and "Double Consonants". <br />Sandhi pronounciation is still in an
      experimental phase.<br /><br />
      <div>
        <h2>Features:</h2>
        <ul>
          <li>
            myanmar unicode romanization/transliteration (BGN,MLCTS,IPA, Okell)
            <br />
            I am using BGN myself. The other transliteration types still needs
            to be double checked
          </li>
          <li>
            stacked character "decompression"/"expansion" (additional inferred
            rules for "Stacked Character", "Simplified Double Stacked Words" and
            "Double Consonants/Modern Closing Consonants")<br />Consonant after
            stacked not changed to voiced Consonant except previous
            EndOfSyllable is Kinza
          </li>
          <li>
            number pronounciation up to a length of 8 digits.
            <br />With weakening (1,2,7) if followed by known classifier
            <a
              href="https://en.wikipedia.org/wiki/Burmese_numerical_classifiers"
              >Wikipedia - Burmese_numerical_classifiers</a
            >
            or noun directly followed by classifier
          </li>
          <li>
            Spoken Pyit exception (Found in Myanmar Script Learning Guide PDF on
            <a href="https://www.asiapearltravels.com/language/lesson33.php"
              >Asiapearltravel - Lesson 33: Learn to read Burmese Script</a
            ><br />
            ပစ် Exception Spoken (Pyit) not (Pit)
          </li>
          <li>
            additional infered rule for ပညာ (pyin2-nya2) //needs to be further
            checked<br />
            <display-syllable consonant="C"></display-syllable
            >+<display-syllable
              consonant="ည"
              vowel="ာ"
              endOfSyllable=""
              toneSentencemark=""
            ></display-syllable>
            →
            <display-syllable
              consonant="C"
              consonantCombinator=""
              endOfSyllable="ဉ်"
            ></display-syllable
            >+<display-syllable consonant="ဉ" vowel="ာ"></display-syllable>
          </li>
        </ul>
      </div>
      <br />
      <div>
        <br />
        <h2>current limitations, errors, questions:</h2>
        <ul>
          <li>
            variable pronounciations. Following variations are always using the
            first variant
          </li>
          <ul>
            <li>ည် (i|e|in)</li>
            <li>ရ (ya|ra) displayed as |Y|</li>
            <li>
              လျှ (sha|hlya) displayed as |Sh| -at least one known exception
              လျှပ်စစ် [electricity](hlyatsit) not (shatsit)
            </li>
          </ul>
          <li>
            needs exact characters. <br />similar looking characters for example
            ၀(ThuNya)[0-Zero] / ဝ(wa) [shiftW german keyboard layout] will
            result in "wrong" romanization
          </li>
          <li>
            မဇ္ဈိမ [center, middle] (/myiʔzímá/) //Anki - different
            decompression needed? (need to further lookup. Idea maybe in
            https://en.wikipedia.org/wiki/MLC_Transcription_System)
          </li>
          <li>
            any rules for "oddballs"? နနွင်း [turmeric]
            (sa-nwin)//https://viss.wordpress.com/2009/01/04/10-things-i-hate-about-the-burmese-language/
          </li>
          <li>
            missing detailed rules for speaking sandhi.
            <ul>
              <li>still figuring out minor syllables</li>
              <li>
                Nasal Consonant changes and weakening to half vowel inaccurate
                without bigger wordlist
              </li>
              <li>
                Noun/Verb list
                <a href="https://github.com/myanmarlinguistics/myanmar-words"
                  >မြန်မာဘာသာဗေဒ (Myanmar Linguistics) - မြန်မာစကားလုံးများ
                  (Myanmar Words / Burmese Words)</a
                >
                too small. Hasn't every common word. For example the compound
                word "အသံတိတ်" is missing in which case the halfVowel result is
                inaccurate? (Example "အသံတိတ်ရုပ်ရှင်")<br />
                Is there a bigger list or a list with extended common words
                available? Are there "rules" for valid compound words?
              </li>
              <li>
                valid word/verb detection limitation: <br />
                valid verb search extended for မ negation. Needed for extended
                negativ compound verb for example နားမလည်. Without extension
                next valid word classification for halfVowel not working since
                လည် would be seen as single syllable word<br />
                In verb dictionary only နားလည် available without marker for
                negativ မ seperator placement. Are there more seperator words
                that can fall inbetween compound words?<br />
                Different verb tense detection not implemented.
              </li>
            </ul>
          </li>
        </ul>
      </div>
    </div>
    <div class="card">
      <h2>
        TODO:
      </h2>
      <ul>
        <li>further checking if my inferred rules are correct</li>
        <li>
          BGN needs to be double check for cross interferences of other
          transliteration system changes.<br />
          Other transliteration systems needs to be double checked.
        </li>
        <li>
          detailed description in prettier format
        </li>
        <li>simplify currently used rules</li>
        <li>improve noun detection (needed for better nasalised consonant changes)<br/>
        example တင်ပါတယ် = verb + tense form not noun+noun+rest</li>
        <li>
          code refactoring (clean up / redundant/unused code removal /
          optimisations)
          <ul>
            <li>
              exchange manual syllable segmentation with adjusted regex of
              <a
                href="https://github.com/myanmaropenwordnet/mya2rom/blob/master/MYA%20Syllable%20Regex.txt"
                >myanmaropenwordnet / mya2rom / MYA Syllable Regex.txt</a
              >
              to better fit my usage.
            </li>
            <li>readjust stacked character processing after changed syllable segmentation</li>
            <li>change vowel after consonant detection/changes with myanmar character matching instead of latin characters</li><!-- ည် |variable vowel| presentation blocking consonant after vowel change and currently not responding to vowel (aw) -->
          </ul>
        </li>
        <li>
          extended Spoken (Sandhi): further checking sandhi (Minor Syllable
          Consonant/Half Vowel Changes and Nasalized Consonant changes)
        </li>
        <li>
          improving valid word check (compoundWord = noun+verb?, verb = (မ
          negation) + verb + tenses)
        </li>
      </ul>
      <br />
      <h2>maybe sometime in the Future (to look into):</h2>
      <ul>
        <li>
          improving number to word preprocessing. The python regex examples of
          <a href="https://github.com/hpbyte/Myanmar_Number_to_Words"
            >hpbyte / Myanmar_Number_to_Words</a
          >
          seems like a good starting point.
        </li>
        <li>
          Myanmar OCR Photo/LiveView as quick reading/pronounciation helper:
          <br />
          Looks promising to include
          <a href="https://tesseract.projectnaptha.com/"
            >https://tesseract.projectnaptha.com</a
          >
        </li>
      </ul>
      <br />
      <h2>far in the Future</h2>
      <ul>
        <li>
          Text2Speech (any ready made open source tts available that can handle
          myanmar?)<br />
          maybe https://github.com/hpbyte/myanmar-tts or directly using
          <a
            href="https://developer.mozilla.org/en-US/docs/Web/API/SpeechSynthesisUtterance"
            >WebSpeech API</a
          >
          with another adjusted transliteration format
          <br />
          Maybe one of the tts systems is adaptable
          <ul>
            <li>tacotron</li>
            <li>https://github.com/as-ideas/TransformerTTS</li>
          </ul>
        </li>
        <!-- 
          //google translation has gotten pretty good. No need to incorporate it for transliteration
        <li>Translation. Any free api available?<br /></li>

        Some interesting stuff
        <ul>
          <li>https://github.com/google/sentencepiece</li>
          <li>
            https://blog.learningdollars.com/2020/01/10/tensorflowjs-how-to-create-a-language-translator/
          </li>
          <li><a href="https://opennmt.net/">opennmt.net</a></li>
        </ul>
        -->
      </ul>
    </div>
  </Layout>
</template>

<script>
import displaySyllable from "./../components/displaySyllable";
import transliterationBox from "./../components/transliterationBox";

export default {
  metaInfo: {
    title: "MyanmarToLatin",
  },
  components: {
    transliterationBox,
    displaySyllable,
  },
  data() {
    return {
      timer: 5,
      timeout: null,
    };
  },
  mounted() {
    //console.log("mounted");
    //let router = this.$router;
    //console.log(router);
    //this.timeout = setTimeout(this.countdownToNextPath, 1000);
    //console.log(this.$refs.btnTimer);
    // this.$refs.btnTimer.classList.add("buttonTimer");
  },
  beforeDestroy() {
    //console.log("beforeDestroy")
    clearTimeout(this.timeout);
  },
  methods: {
    countdownToNextPath() {
      if (this.timer > 0) {
        this.timer -= 1;
        this.timeout = setTimeout(this.countdownToNextPath, 1000);
      } else {
        this.$router.push({ path: "/transliteration-rules/" });
      }
    },
  },
};
</script>

<style></style>
